<!-------------------------------------------------------------------------------
 * Copyright (c) 2020 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0
 *
 * SPDX-License-Identifier: EPL-2.0
 -------------------------------------------------------------------------------->

<app-settings-side-menu
  [appForAdmin]="true">
</app-settings-side-menu>

<app-side-menu-status *appSideMenu="'center'"
                      [appLoadingMessage]="'core.loading' | translate"
                      [appLoading]="(loading$ | async) || searching">
  <ng-container *ngIf="selectedFile != null">
    {{'settings.departments.selectedFile' | translate}}: <br> {{selectedFile.name}}
  </ng-container>

</app-side-menu-status>

<ng-container *appSideMenu="'bottom'">
  <app-action-button (appClick)="anchorElement.click()"
                     [appDisabled]="currentFileUrl == null || (loading$ | async)"
                     [appIcon]="'get_app'"
                     class="openk-info side-menu-button">
    {{'settings.departments.downloadCurrent' | translate}}
  </app-action-button>
  <app-action-button (appClick)="inputElement.click()"
                     [appDisabled]="loading$ | async"
                     [appIcon]="'attach_file'"
                     class="openk-info side-menu-button">
    {{'settings.departments.selectNew' | translate}}
  </app-action-button>
  <app-action-button (appClick)="submit(selectedFileData)"
                     [appDisabled]="selectedFileData == null || (loading$ | async)"
                     [appIcon]="'publish'"
                     class="openk-success side-menu-button">
    {{'settings.departments.submit' | translate}}
  </app-action-button>

  <input #inputElement
         (change)="selectFile(inputElement.files?.item(0)); inputElement.value = null;"
         style="display: none;"
         type="file">
  <a #anchorElement [download]="currentConfigFileName" [href]="currentFileUrl" style="display: none;"></a>
</ng-container>

<div class="title">
  <span class="title--label">
    {{"settings.title" | translate}} - {{"settings.departments.title" | translate}}
  </span>
</div>

<app-collapsible
  [appTitle]="'settings.departments.departments'| translate"
  class="departments-info">
  <div class="departments-info--container">
    <app-list
      *ngFor="let val of (selectedFileData ? selectedFileData : (currentData$ | async)) | getDepartmentGroupsFromTablePipe | objToArray"
      [appListItems]="val.value | appStringArrayToLabelList"
      [appTitle]="val.key">
    </app-list>
    <span
      *ngIf="((selectedFileData ? selectedFileData : (currentData$ | async)) | getDepartmentGroupsFromTablePipe | objToArray).length <= 0">
      {{'settings.departments.placeholderNoDepartments'| translate}}
    </span>
  </div>
</app-collapsible>

<app-collapsible
  [appTitle]="'settings.departments.sectors'| translate"
  class="departments-info">
  <div class="departments-info--container">
    <span>
      <ng-container
        *ngFor="let sector of (selectedFileData ? selectedFileData : (currentData$ | async)) | appSectorsFromDepartment; let last = last;">
        {{sector + (last ? "" : ",")}}
      </ng-container>

      <ng-container
        *ngIf="((selectedFileData ? selectedFileData : (currentData$ | async)) | appSectorsFromDepartment).length === 0">
        {{'settings.departments.placeholderNoSectors'| translate}}
      </ng-container>
    </span>
  </div>
</app-collapsible>

<app-collapsible
  [appTitle]="'settings.departments.organisation'| translate">
  <div class="departments-info--container">
    <app-departments-settings-search
      (appIsSearching)="searching = $event;"
      [appDepartmentList]="(selectedFileData ? selectedFileData : (currentData$ | async)) | objToArray">
    </app-departments-settings-search>
  </div>
</app-collapsible>



